#ifndef __PROTOCOL__
#define __PROTOCOL__

#pragma once

#pragma pack(push)
#pragma pack(1)

typedef struct _DATAHEADER_ {
	// Эʶ;
	byte protocol;
	// ǰͨŰĳ;// header+buf;
	unsigned int len;
	// ;
	byte cmd;
}DataHeader, *pDataHeader;

// 
typedef struct _PACKAGE_
{
	DataHeader header;
	byte	buf[4]; // (ַָ);
}Package;
#pragma pack(pop)

// Эָ;
enum ProtocolCMD
{
	// ¼ǳ;
	CMD_LOGIN					= 0,
	CMD_LOGOUT					= 1,
	// 豸;
	CMD_ADD_DEVICE				= 2,
	CMD_DEL_DEVICE				= 3,
	CMD_QUERY_DEVICES			= 4,
};

typedef struct __TPLOGIN__
{
	char		szUserName[MAX_PATH];
	char		szPassword[MAX_PATH];
}TPLogin, *pTPLogin;

typedef struct _REQUEST_JSON_
{
	int			device_id;
	std::string device_name;
	std::string device_cmd;
	int device_timeout; 
}RequestJson;


typedef struct _RESPONSE_JSON_
{
	int			device_id;
	std::string device_name;
	std::string device_cmd_result;	// ִн;
}ResponseJson;


#endif // __PROTOCOL__