#ifndef __SAT_QUERIER__
#define __SAT_QUERIER__

#pragma once

#include "CritSection.h"

enum DEVICE_TYPE{
	Virtual,
	Usb,
	Reticle
};

// ׿豸adbӣUSBӡ;
typedef struct __ANDROID__ 
{
	int 			nType;		// 0=, 1=usb, 2=;
	std::string 	strName;	// 豸(IP:˿ں);
	/* 
		ʱ,ʱ䳬10,ɾ豸
		Ϊ̻߳һֱӵ豸,ָʱڶδ,
		Ϊ豸IP, ֻAndroidЧ;
	*/
	ULONGLONG		ulOfflineTime;
}STAndroid, *pSTAndroid;

class CSATDevices
{
	CSATDevices(void);
public:
	// ģʽ;
	static CSATDevices* GetInstance()
	{
		static CSATDevices* pInstance = NULL;
		if ( pInstance == NULL )
		{
			pInstance = new CSATDevices;
		}

		return pInstance;
	}

	~CSATDevices(void);

protected:
	// ߳̿ƾ;
	HANDLE  m_hEvent;
	// ߳̾;
	HANDLE	m_hWorkThread;

	// Ƿ׿豸;
	static bool s_bEnableAndroid;
	// ߲ʱ,λ;
	static ULONGLONG s_ulEraseDuration;	
	// ߳;
	static ThreadSection s_ThreadSection;
	// ׿豸б;
	static std::vector<STAndroid> s_vtAndroids;	

	// ӿ;
public:
	// ʼ;	
	void StartWork();
	// ;
	void EndofWork();

	// ߳;
	static DWORD WINAPI WorkThread(LPVOID lpVoid);


	// 豸;
	static void AddReticleDevices(std::string ip);
	static void AddVirtualDevices(std::string name);
	// 豸Ƿ;
	static bool IsDeviceExist(STAndroid &stAndroid);
	// 豸Ƿ;
	static bool IsAndroidOffline(STAndroid &stAndroid, std::vector<STAndroid> &vtAndroids );
	static bool IsAndroidOffline(std::string strAndroidName, std::vector<STAndroid> &vtAndroids );
	// Ƿ豸;
	static bool IsNewAndroid(STAndroid &stAndroid);
	static bool IsNewUsbAndroid(STAndroid &stAndroid);
	// ȡǰ豸б;
	static void GetCurrentDevices(std::vector<STAndroid> &vtAndroids);
	// 豸;
	static void ReConnectAllDevices();

};

#endif // __SAT_QUERIER__