#include "stdafx.h"
#include <direct.h>

bool MKDIR(LPCTSTR dir) 
{
	//////////////////////////////////////////////////////////////////////////
	// Ŀ¼;
	int nleft = 0;
	int nIndex = -1;
	std::string strdir = dir;
	strdir = strdir.substr(0, strdir.find_last_of(_T("\\")));

	if (strdir.at(strdir.size() - 1) != _T('\\'))
		strdir.append(_T("\\"));

	// ·Ӳ̷;
	if (_tcscmp(strdir.substr(0, 2).c_str(), _T("\\\\")) == 0)
		nleft = strdir.find_first_of(_T("\\"), 2) + 1;	// ȥ;
	else if (strdir.at(2) == _T('\\'))
		nleft = 3;

	do
	{
		nIndex = strdir.substr(nleft, -1).find_first_of(_T("\\"));

		if (nIndex != std::string::npos)
		{
			if (_mkdir(strdir.substr(0, nIndex + nleft).c_str()) == -1 && (errno != EEXIST))
			{
				return false;
			}

			nleft += nIndex + 1;
		}
	} while (nIndex != -1);

	return true;
};

__if_not_exists(NotifyJobStart)
{
	int NotifyJobStart(std::string url, const SATParameters::STNotifyJobStartReq &stNotifyJobStartReq, SATParameters::STNotifyJobStartResp &stNotifyJobStartResp) throw()
	{
		return SetResult(url, stNotifyJobStartReq, stNotifyJobStartResp);
	}
}

__if_not_exists(ProcessJob)
{
	int ProcessJob(std::string url, const SATParameters::STJobProcessReq &stJobProcessReq, SATParameters::STJobProcessResp &stJobProcessResp) throw()
	{
		return SetResultList(url, stJobProcessReq, stJobProcessResp);
	}
}

int test()
{
	//std::string host = "http://10.118.158.52:8580";//"http://10.118.158.198:8090";
	std::string host = "http://10.126.16.60:8580";
	SATParameters::STDevice stDevice;
	stDevice.strStatus = "0";
	stDevice.strDeviceSerial = "192.168.1.119:5555";
	stDevice.strHardwareVersion = "MS6488";
	stDevice.strManu = "MStar";
	stDevice.strDeviceMac = "";
	stDevice.strLastJobStartTime = "";
	stDevice.strLastTimeBreak = "";
	stDevice.strComments = "";
	stDevice.strCPU = "";
	stDevice.strSoftwareVersion = "1522659174";
	stDevice.strPhoneNumber = "";
	stDevice.strLastJobFinishTime = "";
	stDevice.strMemory = "";
	stDevice.strModel = "Generic Linux on tcl_ms6488_cn_64_n";
	stDevice.strLastJob = "";
	stDevice.strLastTimeConnected = "2019-12-16 10:16:01";
	stDevice.strElectric = "";
	// ##########################ȵ¼##############################;
	SATParameters::STLoginReq stLoginReq;
	SATParameters::STLoginResp stLoginResp;
	std::string url = host + "/btc_execute_se/ajaxInteractiveManage!executeLogin.action";
	// ʾֵ;
	stLoginReq.strUserName = "superAdmin";
	stLoginReq.strStatus = "0";
	stLoginReq.strDeleteStatus = "";
	stLoginReq.strIP = "10.118.158.175";
	stLoginReq.strStorage = "";
	stLoginReq.strConnectTime = "";
	stLoginReq.strExecuteName = "";
	stLoginReq.strMAC = "40:16:7e:23:10:53";
	stLoginReq.strDisconnectTime = "";
	stLoginReq.strPassword = "123456";
	stLoginReq.strCPU = "";

	if ( !Login(url, stLoginReq, stLoginResp) )
	{
		system("pause");
		return -1;
	}

	printf("¼أcode=%s, msg=%s, str=%s, portCount=%d, companyid=%d, runnertoken=%s\n",
		stLoginResp.strCode.c_str(),
		stLoginResp.strMessage.c_str(),
		stLoginResp.strStr.c_str(),
		stLoginResp.nPortCount,
		stLoginResp.nCompanyId,
		stLoginResp.strRunnerToken.c_str()
		);		

	// ##########################豸Ϣ##############################;
	SATParameters::STUpdateDeviceReq stUpdateDeviceReq;
	SATParameters::STUpdateDeviceResp stUpdateDeviceResp;
	__if_not_exists(url)
	{			
		std::string url = host + "/btc_execute_se/ajaxInteractiveManage!updateDeviceMessage.action";
	}
	__if_exists(url)
	{
		url = host + "/btc_execute_se/ajaxInteractiveManage!updateDeviceMessage.action";
	}

	stUpdateDeviceReq.strStatus = "0";
	stUpdateDeviceReq.strUserName = "superAdmin";		
	stUpdateDeviceReq.strIP = "10.118.158.175";
	stUpdateDeviceReq.strStorage = "228092536KB";
	stUpdateDeviceReq.strRunnerName = "SAT-Admin";
	stUpdateDeviceReq.strMAC = "40:16:7e:23:10:53";
	stUpdateDeviceReq.strReportType = "1";
	stUpdateDeviceReq.strStartTime = "2019-12-16 19:15:30";
	stUpdateDeviceReq.strMemory = "8938544KB";
	stUpdateDeviceReq.strEndTime = "";
	stUpdateDeviceReq.strCPU = "24.7%";
	stUpdateDeviceReq.devicelist.push_back(stDevice);

	if ( UpdateDeviceMessage(url, stUpdateDeviceReq, stUpdateDeviceResp) )
	{
		printf("豸Ϣɹcode=%s, msg=%s, str=%s\n",
			stLoginResp.strCode.c_str(),
			stLoginResp.strMessage.c_str(),
			stLoginResp.strStr.c_str());
	}
	else
	{
		printf("豸Ϣʧ!\n");
	}

	//system("pause");
	//return 1;

	while(true)
	{
		// ########################################################;
		SATParameters::STHeartbeatReq stHeartbeatReq;
		SATParameters::STHeartbeatResp stHeartbeatResp;
		__if_not_exists(url)
		{			
			std::string url = host + "/btc_execute_se/ajaxInteractiveManage!executeHeartbeat.action";
		}
		__if_exists(url)
		{
			url = host + "/btc_execute_se/ajaxInteractiveManage!executeHeartbeat.action";
		}

		// ʾֵ;
		//stDevice.strStatus = "0";
		//stDevice.strDeviceSerial = "192.168.1.119:5555";

		stHeartbeatReq.strUserName = "superAdmin";
		stHeartbeatReq.strRunnerMac = "40:16:7e:23:10:53";
		stHeartbeatReq.devicelist.push_back(stDevice);
		if ( Heartbeat(url, stHeartbeatReq, stHeartbeatResp) )
		{
			printf("¼أcode=%s, msg=%s, str=%s\n",
				stHeartbeatResp.strCode.c_str(),
				stHeartbeatResp.strMessage.c_str(),
				stHeartbeatResp.strStr.c_str());

			// жǷȡɹ;
			if ( stHeartbeatResp.vtTask.size() )
			{
				// #########################################################################################
				// ֪ͨSAT״̬;
				SATParameters::STTask stTask = stHeartbeatResp.vtTask[0];
				SATParameters::STNotifyJobStartReq stNotifyJobStartReq;
				SATParameters::STNotifyJobStartResp stNotifyJobStartResp;

				__if_not_exists(url)
				{			
					std::string url = host + "/btc_execute_se/ajaxInteractiveManage!setResult.action";
				}
				__if_exists(url)
				{
					url = host + "/btc_execute_se/ajaxInteractiveManage!setResult.action";
				}

				TCHAR szValue[36] = {0};
				_itoa_s(stTask.nDeviceId, szValue, 10);
				stNotifyJobStartReq.strDeviceId = szValue;

				_itoa_s(stTask.nExecuteId, szValue, 10);
				stNotifyJobStartReq.strExecuteId = szValue;

				// _itoa_s(stTask.nInstanceId, szValue, 10); // 󵼣ӦʹidnInstanceId
				_itoa_s(stTask.Id, szValue, 10);
				stNotifyJobStartReq.strInstanceId = szValue;					

				_itoa_s(stTask.nTaskId, szValue, 10);
				stNotifyJobStartReq.strTaskId = szValue;

				stNotifyJobStartReq.strSignalImageUrl = "D:\\\\SAT\\\\Runner\\\\btc_runner_se\\\\runner\\\\output\\\\";//ODF_NPI_RT2841\\\\20191216101613370\\\\192.168.1.119_5555";
				stNotifyJobStartReq.strSignalImageUrl.append(stTask.strTaskName+"\\\\");
				stNotifyJobStartReq.strSignalImageUrl.append(stTask.Job.strUniqueId+"\\\\");
				stNotifyJobStartReq.strSignalImageUrl.append(stTask.Job.strDeviceId);

				for( int n = 0; n < 2; n++)
				{						
					// ѯǷSATϴ;
					if ( NotifyJobStart(url, stNotifyJobStartReq, stNotifyJobStartResp) )
					{
						// 豸Ϊæµ״̬;
						// æµ״̬ʱHeartbeatѯ;
						stDevice.strStatus = "2";
						printf("NotifyJobStart ɹ\n");
					}
					else
					{
						printf("NotifyJobStart ʧ\n");
					}
				}

				stDevice.strStatus = "0";
				// #########################################################################################
				// ʼJob;
				SATParameters::STJobProcessReq stJobProcessReq;
				SATParameters::STJobProcessResp stJobProcessResp;
				__if_not_exists(url)
				{			
					std::string url = host + "/btc_execute_se/ajaxInteractiveManage!setResultList.action";
				}
				__if_exists(url)
				{
					url = host + "/btc_execute_se/ajaxInteractiveManage!setResultList.action";
				}

				{
					stJobProcessReq.strResultState = "1";
					stJobProcessReq.strCaseScene = "";
					stJobProcessReq.strCaseStep = "0";
					stJobProcessReq.strApkMD5 = "";
					stJobProcessReq.strCrashTime = "";
					// TaskеExecuteId
					_itoa_s(stTask.nExecuteId, szValue, 10);
					stJobProcessReq.strRunnerId = szValue;
					stJobProcessReq.strCPUInfo = "0";
					stJobProcessReq.strRunnedActionNameList = "";
					stJobProcessReq.strArtificialResult = "";
					stJobProcessReq.strArtificialModify = "";
					stJobProcessReq.strRunnerName = "";
					stJobProcessReq.strTaskType = "FUNCTIONALITY";
					stJobProcessReq.strCaseRepeat = "";
					stJobProcessReq.strApplicationGroup = "";
					// ʵId;
					_itoa_s(stTask.nInstanceId, szValue, 10);
					stJobProcessReq.strInstanceId = szValue;
					stJobProcessReq.strCaseId = "";
					stJobProcessReq.strProgress = "0";
					stJobProcessReq.strReusltMessage = "ʼ";
					stJobProcessReq.strJobRepeat = "";
					stJobProcessReq.strScreenShot = "";
					stJobProcessReq.strStartTime = "2019-12-16 101643";
					stJobProcessReq.strCrashNumber = "";
					stJobProcessReq.strCaseName = "";
					stJobProcessReq.strFailedReason = "";
					stJobProcessReq.strImgName = "";
					stJobProcessReq.strCaseIndex = "";
					// ʵId;
					_itoa_s(stTask.nDeviceId, szValue, 10);
					stJobProcessReq.strDeviceId = szValue;
					stJobProcessReq.strSceneIndex = "";
					// ʵId;
					_itoa_s(stTask.nTaskId, szValue, 10);
					stJobProcessReq.strTaskId = szValue;
					stJobProcessReq.strAnalysis = "";
					// 豸ƣDeviceSerial;
					stJobProcessReq.strDevnceName = stDevice.strDeviceSerial;
					// ̶ΪTOTAL
					stJobProcessReq.strInfoType = "TOTAL";
					// Android豸,Ҫͨadbȡ;
					stJobProcessReq.strMemoryInfo = stDevice.strMemory;
					stJobProcessReq.strEndTime = "2019-12-16 10:18:20";
					stJobProcessReq.strRoundNumber = "1";
					stJobProcessReq.strResultType = "0";
					stJobProcessReq.strOperationStep = "";
				}

				// 
				if ( ProcessJob(url, stJobProcessReq, stJobProcessResp) )
				{
					// ʼؽű;
					__if_not_exists(url)
					{			
						std::string url = host + "/btc_caseManagement_se/ajaxInteractiveManage!getCaseFileListUrl.action";
					}
					__if_exists(url)
					{
						url = host + "/btc_caseManagement_se/ajaxInteractiveManage!getCaseFileListUrl.action";
					}

					SATParameters::STScriptUrlResp stScriptUrlResp;
					std::vector<SATParameters::STCase>::iterator it = stTask.Job.vtCases.begin();
					for ( ; it != stTask.Job.vtCases.end(); it++ )
					{
						if ( DownloadScript(url, it->strId, "D:\\SAT\\", stScriptUrlResp) )
						{
							printf("ȡűصַɹ:%s\n·%s\n", stScriptUrlResp.strURL.c_str(), stScriptUrlResp._strScripFile.c_str());
							DWORD dwScriptId = RunPyScript(stScriptUrlResp._strScripFile.c_str(), "", "D:\\SAT\\log.txt", TRUE);
							if ( dwScriptId != -1 )
							{
								ULONGLONG ulTickCount = GetTickCount64();
								while( !IsPyScriptOver(dwScriptId, TRUE) )
								{
									Sleep(1000);
									//if ( GetTickCount64() - ulTickCount > 1800000)
									if ( GetTickCount64() - ulTickCount > 1200000)
									{
										break;
									}
								}
							}
							CleanPyScript(dwScriptId);
						}
						else
						{
							printf("ȡűصַʧ\n");
						}
					}						
				}
			}
		}

		Sleep(30000);
	}

	
	system("pause");
}